package com.docus.server.infrastructure.dao.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.docus.core.util.Func;
import com.docus.infrastructure.core.db.dao.impl.BaseDaoImpl;
import com.docus.infrastructure.web.request.SearchDTO;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.entity.segmentation.OcrBasicTest;
import com.docus.server.entity.segmentation.OcrFileInfo;
import com.docus.server.infrastructure.dao.IOcrFileInfoDao;
import com.docus.server.infrastructure.mapper.OcrFileInfoMapper;
import com.github.pagehelper.PageHelper;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

/**
 * ocr文件信息 数据访问实现类
 *
 * @author AutoGenerator
 * @since 2023-08-29
 */
@Repository
public class OcrFileInfoDaoImpl extends BaseDaoImpl<OcrFileInfoMapper, OcrFileInfo> implements IOcrFileInfoDao {

    /**
     * 按主键查询
     *
     * @param id 主键Id
     * @return 实体
     */
    @Override
    public OcrFileInfo findById(Long id) {
        return super.findById(id);
    }

    /**
     * 新增
     *
     * @param ocrFileInfo 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean add(OcrFileInfo ocrFileInfo) {
        return super.save(ocrFileInfo);
    }

    /**
     * 编辑
     *
     * @param ocrFileInfo 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean edit(OcrFileInfo ocrFileInfo) {
        return super.updateById(ocrFileInfo);
    }

    /**
     * 批量删除
     *
     * @param ids 主键ids
     * @return 成功或失败
     */
    @Override
    public int delete(List<Long> ids) {
        return super.deleteByIds(ids);
    }

    /**
     * 关键字搜索
     *
     * @param searchDTO 搜索参数
     * @return 分页列表
     */
    @Override
    public PageResult<OcrFileInfo> search(SearchDTO searchDTO) {
        //分页
        PageHelper.startPage(searchDTO.getPageNum(), searchDTO.getPageSize());
        LambdaQueryWrapper<OcrFileInfo> query = Wrappers.lambdaQuery();

        Object patientId = searchDTO.getParams("patientId");
        Object assortId = searchDTO.getParams("assortId");
        Object picName = searchDTO.getParams("picName");



        if (Func.isNotEmpty(patientId)) {
            query.eq(OcrFileInfo::getPatientId, patientId);
        }
        if (Func.isNotEmpty(assortId)) {
            query.like(OcrFileInfo::getAssortId, String.format("%s%s%s","%", assortId,"%"));
        }
        if (Func.isNotEmpty(picName)) {
            query.like(OcrFileInfo::getPicName, String.format("%s%s%s","%", picName,"%"));
        }


        //默认createTime倒序排序
        query.orderByDesc(OcrFileInfo::getCreateTime);
        List<OcrFileInfo> list = super.find(query);
        return new PageResult<>(list);
    }

    /**
     * 名称不重复
     *
     * @param id   主键
     * @param name 名称
     * @return 名称重复数量
     */
    @Override
    public int findByIdAndName(Long id, String name) {
        LambdaQueryWrapper<OcrFileInfo> query = Wrappers.lambdaQuery();
        if (id != null) {
            query.ne(OcrFileInfo::getId, id);
        }
        //if (Func.isNotBlank(name)) {
        //   query.eq(OcrFileInfo::getName, name);
        //}

        return baseMapper.selectCount(query);
    }
}
